import java.util.*;
public class GEOK{
/**Irnytott grf ersen sszefgg komponenseinek kiszmtsa
 */	
	private enum Paletta {Feher, Szurke, Fekete};
	private static Paletta[] Szin;
	private static Verem<Integer> V;
	private static Graf GT;
				
	private static void MelyBejar(Graf G, int p){
		Szin[p]=Paletta.Szurke;
		for (int q:G.KiEl(p))		//p->q
			if (Szin[q]==Paletta.Feher)
				MelyBejar(G,q);
		Szin[p]=Paletta.Fekete;
		V.VeremBe(p);
	}
	private static Graf Transzponal(Graf G){
		GT=new GrafA(G.Maxpont(),"Lanc");
		Iterator<GrafEl> elek=G.ElIterator();
		while (elek.hasNext()){
			GrafEl tel=elek.next();
			GT.ElBovit(tel.be, tel.ki);
		}	
		return GT;
	}	
	private static void MelyKeres(Graf G){
		Szin =new Paletta[G.Maxpont()+1];
		for (int p:G)
			Szin[p]=Paletta.Feher;
		V=new VeremL<Integer>();
		for (int p:G)
			if (Szin[p]==Paletta.Feher)
				MelyBejar(G,p);				
	}
	private static void MelyBejarT(Graf G, int p, Halmaz<Integer> H){
		H.Bovit(p);
		Szin[p]=Paletta.Szurke;		
		for (int q:G.KiEl(p))		//p->q
			if (Szin[q]==Paletta.Feher)		
				MelyBejarT(G,q, H);
		Szin[p]=Paletta.Fekete;
	}
/**
 *@return a G grf ersen sszefgg komponensei
 */
	public static Halmaz<Halmaz<Integer>> GEOK(Graf G){
		Halmaz<Integer> H;
		Halmaz<Halmaz<Integer>> S;
		MelyKeres(G);
		GT=Transzponal(G);
				for (int p:G)
			Szin[p]=Paletta.Feher;
		
		S=new HalmazL<Halmaz<Integer>>();
		while (V.NemUres()){
			int p=V.VeremBol();
			if (Szin[p]==Paletta.Feher){
				H=new HalmazL<Integer>();
				MelyBejarT(GT,p, H);
				S.Bovit(H);	
			}
		}
		return S;
	}
}